! Original sample: Demonstrates the GPS commands
! In addition, it is screen orientation sensitive,
!  draws some objects, and have rectangular touch zones.
! The last modification permits lighting a LED via Bluetooth
! Additions by Vasile Guta Ciucur.

GPS.OPEN
GR.OPEN 255, 0, 0, 0
GR.ORIENTATION -1 

! init variables
led1_status = 0
led2_status = 0

! open and connect to bluetooth device
bt.open
bt.connect

!wait until connection is established
do
  bt.status s
until s=3

! loop at every 10ms ... just for test...
loop:

! get the screen size to have the new values at every step in the loop.
! it will be great to get them only when these are changed...
GR.SCREEN w, h
GR.COLOR 255,200,150,150,0

! calculations dependant on screen orientation:
! the center of the "radar", text size and position, buttons, leds, things like that :P.

if h < w then
  ! LANDSCAPE MODE
  ! coordinates for text and radar
  sp = h/14
  pad = 0.20 * sp
  GR.TEXT.SIZE sp - 2.18*pad
  w_quarter = w/4
  x_circle = w_quarter * 3
  y_circle = h/2
  raza = w_quarter - 20
  
  ! origin for buttons
  left_r = (w/4) / 2
  ! drawing the buttons 'cause locations are not the same as in portrait mode 
  ! and assign them a touch zone
  gr.set.stroke 4
  y  = 7*sp + sp - pad
  ly1 = y + sp
  lx2 = left_r + sp * 4
  ly2 = y + sp * 2
  gr.rect button1, left_r, ly1, lx2, ly2
  gr.bounded.touch bt1_touched, left_r, ly1, lx2, ly2
  if bt1_touched
    if led1_status = 1
      led1_status = 0
    else
      led1_status = 1
    endif
    pause 100
  endif
  
  y  = 9*sp + sp - pad
  ly1 = y + sp
  lx2 = left_r + sp * 4
  ly2 = y + sp * 2
  gr.rect button2, left_r, ly1, lx2, ly2  
  gr.bounded.touch bt2_touched, left_r, ly1, lx2, ly2
  if bt2_touched
    !if led2_status = 1
    !  led2_status = 0
    !else
     ! led2_status = 1
    !endif
    bt.close
    gr.close
    goto onerror
  endif
  
  ! drawing LEDs according to their status
  y = 8*sp + sp + pad
  gr.set.stroke pad + 8
  if led1_status = 1
    GR.COLOR 255,200,0,0,0
    bt.write "1"
  else
    GR.COLOR 255,50,0,0,0
    bt.write "0"
  endif
  gr.circle led1, left_r/2, y, pad
  bt.status bs
  if bs = 3
    GR.COLOR 255,0,200,0,0
  else
    GR.COLOR 255,0,50,0,0
  endif
  y = 10*sp + sp + pad
  gr.circle led2, left_r/2, y, pad
  gr.set.stroke 0 
  GR.COLOR 255,200,150,150,0
  gr.set.stroke 0 
else
  ! PORTRAIT MODE
  ! coordinates for text and radar
  sp = w/12
  pad = 0.20 * sp
  GR.TEXT.SIZE sp - 2.18*pad
  h_quarter = h/4
  x_circle = w/2
  y_circle = h_quarter * 3
  raza = h_quarter - 20
  
  ! origin for buttons
  left_r = ((w/4) * 3) - ((w/4) / 2)
  ! drawing the buttons 'cause locations are not the same as in landscape mode
  ! and assign them a touch zone
  gr.set.stroke 4
  y  = 2*sp + sp - pad
  ly1 = y + sp
  lx2 = left_r + sp * 4
  ly2 = y + sp * 2
  gr.rect button1, left_r, ly1, lx2, ly2
  gr.bounded.touch bt1_touched, left_r, ly1, lx2, ly2
  if bt1_touched
    if led1_status = 1
      led1_status = 0
    else
      led1_status = 1
    endif
    pause 100
  endif
  
  y  = 4*sp + sp - pad
  ly1 = y + sp
  lx2 = left_r + sp * 4
  ly2 = y + sp * 2
  gr.rect button2, left_r, ly1, lx2, ly2
  gr.bounded.touch bt2_touched, left_r, ly1, lx2, ly2
  if bt2_touched
    !if led2_status = 1
    !  led2_status = 0
    !else
    !  led2_status = 1
    !endif
    bt.close
    gr.close
    goto onerror
  endif
  
  ! drawing LEDs according to their status
  y = 2*sp + sp - pad
  gr.set.stroke pad + 8
  if led1_status = 1
    GR.COLOR 255,200,0,0,0
    bt.write "1"
  else
    GR.COLOR 255,50,0,0,0
    bt.write "0"
  endif
  gr.circle led1, left_r+sp, y+(pad/2), pad
  bt.status bs
  if bs = 3
    GR.COLOR 255,0,200,0,0
  else
    GR.COLOR 255,0,50,0,0
  endif
  left_r = (w/4) * 3
  gr.circle led2, left_r+sp, y+(pad/2), pad
  gr.set.stroke 0 
  GR.COLOR 255,200,150,150,0
endif

! put the text at 20pixels distance from left margin of the tablet screen.
x = 20
! now, a tab for number's column.
tab_nr = w/4
raza_quarter = raza/4
r2 = raza_quarter * 3
r3 = raza_quarter * 2

! draw the "radar" circles
gr.circle cr, x_circle, y_circle, raza
!GR.MODIFY cr, "x", x_circle
!GR.MODIFY cr, "y", y_circle 
!GR.MODIFY cr, "radius", raza
gr.circle c2, x_circle, y_circle, r2
gr.circle c3, x_circle, y_circle, r3
gr.circle c4, x_circle, y_circle, raza_quarter

! draw the "radar" lines
gr.line l1, x_circle, y_circle, x_circle, y_circle+raza
gr.line l1, x_circle, y_circle, x_circle, y_circle-raza
gr.line l1, x_circle, y_circle, x_circle+raza, y_circle
gr.line l1, x_circle, y_circle, x_circle-raza, y_circle

y  = 0*sp + sp - pad
GPS.PROVIDER provider$
GR.TEXT.DRAW p, x, y, "Provider: "
GR.TEXT.DRAW p, tab_nr, y, provider$

y  = 1*sp + sp - pad
GPS.ACCURACY accuracy
GR.TEXT.DRAW p, x, y, "Accuracy: " 
GR.TEXT.DRAW p, tab_nr, y, FORMAT$("##", accuracy) + " meter(s)"

y  = 2*sp + sp - pad
GPS.LATITUDE latitude
GR.TEXT.DRAW p, x, y, "Latitude: " 
GR.TEXT.DRAW p, tab_nr, y, FORMAT$("##%.#####", latitude)

y  = 3*sp + sp - pad
GPS.LONGITUDE longitude
GR.TEXT.DRAW p, x, y, "Longitude: " 
GR.TEXT.DRAW p, tab_nr, y, FORMAT$("##%.#####", longitude)

y  = 4*sp + sp - pad
GPS.ALTITUDE altitude
GR.TEXT.DRAW p, x, y, "Altitude: " 
GR.TEXT.DRAW p, tab_nr, y, FORMAT$("#####", altitude)

y  = 5*sp + sp - pad
GPS.BEARING bearing
GR.TEXT.DRAW p, x, y, "Bearing: " 
GR.TEXT.DRAW p, tab_nr, y, FORMAT$("##%.##", bearing)

y  = 6*sp + sp - pad
GPS.SPEED speed
GR.TEXT.DRAW p, x, y, "Speed: " 
GR.TEXT.DRAW p, tab_nr, y, FORMAT$("##%.##", speed)

y  = 7*sp + sp - pad
GR.TEXT.DRAW p, x, y, "Great example! - orientation sensitive"

GR.RENDER
PAUSE 10
GR.CLS

GOTO loop

ONERROR:
print "did you liked it?"
print "press return again to enter in edit mode"
END
